
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[测试技术思考] 软件可测性分析和实践 / 憋错料</title>

    <meta name="description" content="[测试技术思考] 软件可测性分析和实践 软件测试中可测性一般是指对系统的可控性.可观测性进行的评估,借以反映系统设计.实现对测试的友好程度和相应的测试成本.可测性在测试阶段会对系统的测试成本及关联产品代码的Patch次数产生重大影响.如何提高可测性成为软件生命周期特别是前期(设计阶段.coding阶段)重要的一环. 本文带领大家探索在实际项目中可测性相关的实战经验和对应的改进措施. 1 提高可测性的切入点 可测性的评估和改进最早开始于两个阶段: a. 新项目的设计阶段: b. 已有项目新功能.新策略的提测阶段. 这些是提高团队设计的系">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">[测试技术思考] 软件可测性分析和实践</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>软件测试中可测性一般是指对系统的可控性、可观测性进行的评估，借以反映系统设计、实现对测试的友好程度和相应的测试成本。可测性在测试阶段会对系统的测试成本及关联产品代码的Patch次数产生重大影响。如何提高可测性成为软件生命周期特别是前期（设计阶段、coding阶段）重要的一环。 本文带领大家探索在实际项目中可测性相关的实战经验和对应的改进措施。</p>
<h2>1 提高可测性的切入点</h2>
<p>可测性的评估和改进最早开始于两个阶段：</p>
<p>a. 新项目的设计阶段；</p>
<p>b. 已有项目新功能、新策略的提测阶段。</p>
<p>这些是提高团队设计的系统可测性和维持系统的设计高可测性的关键时间点。测试人员会利用各种场合、机会强化开发人员对于可测性的重视：</p>
<ol>
<li>可测性的重要性每次设计讨论会， 测试负责人必提醒大家在设计时注意可测性。否则设计出来的功能很可能需要进行重构。</li>
<li>可控性
<p>每次晨会中的讨论环节， 测试负责人会提醒模块设计人员，设计的功能需要必要的外部控制、执行动作支持，否则QA无法精确控制过程及缩短测试耗时。</li>
<li>可观测性每个功能进行测试设计阶段，提前和开发人员沟通必要的功能，观察结果集合可以系统外部获得，错误结果可以被暴露而不是由内部逻辑完全消化。</li>
</ol>
<p>那可控性和可观测性又指哪些方面呢？ 如何向开发人员合理的解释可测性？</p>
<h3>1.1 可控性</h3>
<p>可控性指系统的状态可受外部控制改变，而不是由内部模块自发的完成。</p>
<p>举个常见的例子：</p>
<p>A. 当某文件存在的时候，该模块自动退出；</p>
<p>B. 当某pid.lock文件存在时，该模块不能启动，即使启动也退出。</p>
<p>上面的状态改变都是由一个外部的文件控制，拥有可控性。</p>
<p>说到这里，问题来了，拥有可控性就万事大吉了吗？ 请大家思考，你在实际项目过程中遇到过哪些有可控性但可控性较差的情况？</p>
<h3>1.2 可观测性</h3>
<p>可观测性指系统内的重要状态、信息可通过一定手段由外部获得。可观测性不仅能观测系统的输出是否符合设计要求，还影响该系统是否可控。系统的必要状态信息在系统测试控制阶段起决定作用。没有准确的状态信息，测试人员无法判断是否要进行下一步的控制变更。无法控制状态变更，可控性又从何谈起？</p>
<p>口说无凭，我们来看几个作者实际项目中遇到的真实案例。</p>
<h2>2 实战分析</h2>
<h3>[1] 垃圾回收GC</h3>
<p>垃圾回收GC模块是常见的系统内模块，相信很多测试人员遇到过下面场景或者类似场景：</p>
<p>开发人员终于在大吼一声后宣布垃圾回收模块完成，她的描述如下：</p>
<p>1) 该模块定时自动触发。触发条件是每天晚上1点。</p>
<p>2) 该模块触发后每秒的处理量是N/s。是根据线上情况得到的经验值，硬编码到代码中。</p>
<p>然后，就没有然后了。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3Jlcy5pbmZvcS5jb20vYXJ0aWNsZXMvdGVzdGFiaWxpdHktYW5hbHlzaXMtYW5kLXByYWN0aWNlL3poL3Jlc291cmNlcy8xMTA3MDQwLmpwZw==.jpg"></p>
<p>测试人员一阵迷茫，这就是全部的询问换来的基本上是“它都是全自动的了，你还想要什么的”表情。</p>
<p>因此这个新功能完成后的二次返工是必然的了。</p>
<p>首先，该模块的可控性太差。测试环境不可以等待每天晚上1点这个时刻，必须有外部能影响这个”全自动“的手段提供。否则全量的系统测试用例回归会被限定在固定测试时间点且无法调整和更改。</p>
<p>其次，该模块的每秒处理量必须能更改到符合测试环境。测试环境基本上都是真实环境的放缩，特别是分布式系统等大规模应用。测试环境机器无论是数量还是类型都远低于实际环境。这种条件下，参数的定量调整是必须要完成的辅助支持。</p>
<p>再次，没有必要的描述如何判断哪些文件/数据被GC掉了。无法观测到执行结果集带来的后果是无法精确的预期测试结果。</p>
<p>而相应的改进措施就是解决上面提到的问题。</p>
<h3>[2] 系统内部状态信息</h3>
<p>为了保证存储的数据高可用，分布式系统会采取多机存储副本方法。即一个数据被N（&gt;=2）个机器以一定的算法存储相同的数据副本。这个时候经常会遇到的问题：</p>
<p>a) 机器间的数据由于数据复制顺序的不同，会有数据差异。a、b、c三台机器，a、b机器可能已完成一次数据的更新到最新数据版本data1，c还处于老版本data0.</p>
<p>b) 由于版本差异，内部必须维护副本revision的版本号以进行数据同步和异常处理。</p>
<p>这种情况， 好的设计原则上要保证多机副本的必要状态信息被外部获取。</p>
<p>A. 数据的副本分布信息、副本的revision版本号等需要提供接口获得</p>
<p>B.由于机器宕机造成的副本分布变化要能够及时反映和更新。（比如带一定间隔周期的更新）</p>
<p>只有在这种必要信息被获取的情况下，测试人员才能更好的掌握系统状态并根据系统状态进行清晰的测试结果预期。</p>
<h3>[3] 参数的热设定</h3>
<p>参数的热设定是经常碰到的问题。一个系统越复杂、可定制，它可设定的参数就越多。一个好的设计应该能热设定其中的参数，然后执行重新加载动作。</p>
<p>举个实际的例子， 下面的配置文件是一个系统的存储节点配置文件截图。该截图仅展示了大约1/5的配置参数。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3Jlcy5pbmZvcS5jb20vYXJ0aWNsZXMvdGVzdGFiaWxpdHktYW5hbHlzaXMtYW5kLXByYWN0aWNlL3poL3Jlc291cmNlcy8xMTA3MDQxLnBuZw==.jpg"></p>
<p>a. 如果参数不可重新热加载，那么测试用例执行过程中都必须进行进程的重启。</p>
<p>进程的重启势必造成单个测试用例的时间拉长，复杂系统成百+的测试用例会造成总体测试时间的拉长。每个多消耗1-2分钟，整体就是小时级别的时间消耗。这对Slow build或完整性测试集执行来说是个灾难。可测性也比较差。</p>
<p>b. 参数不可热加载会在系统运维期间失去热调整参数的机会，可能导致系统的间断性停服务。这对基础服务来说是个噩梦，上层依赖于基础服务的应用可能成百上千，停服的代价过于大。一些gdb强行attach进程进行等修改变量的临时方法由于进程状态的不确定性因素会带来不小的风险。作者负责的项目曾出现gdb热修改带来集群主控节点宕机停集群的惨痛经历。</p>
<p>参数的热设定和加载虽然增加了一定的逻辑复杂度，但对比带来的收益是值得付出并实践的。</p>
<h3>[4] 系统使用信息统计</h3>
<p>系统使用信息的统计在如下方面特别重要:</p>
<p>1) 产品线运营数据，为产品运营、后续产品改进等环节提供一手资料</p>
<p>2) 运用系统、集群状态信息监控以解决运维过程中发生的问题</p>
<p>3) 利用系统状态信息进行内部运行状态判定，以测试是否达预期</p>
<p>1和2虽然不直接涉及可测性，但测试人员在系统设计阶段需要进行这方面的考虑以防止系统开发后期进行的功能性重构带来测试整体架构重构。系统接近尾声进行的功能性重构对测试人员来说是个非常头疼的问题。测试用例依赖的统计信息等接口可能被大量使用，这类的更改带来不小的用例调整、更正工作。</p>
<p>测试人员在信息统计的设计阶段需要了解系统在现有的设计基础上可能衍生的二期、三期甚至更后期的功能，以提前影响当前的功能设计，提高数据、接口、操作方面的可扩展性。为以后可能产生的新功能打好可测性基础。少埋坑、多考虑场景适应性。</p>
<p>上面的场景是作者在实际测试项目中经常遇到的，因此抽取出来做个示例。实际的项目测试遇到的场景远比这些复杂、多样且不可预知。这个时候需要大家多思考场景，多根据已有的经验进行防御性准备。</p>
<p>那有没有通用的提供可测性的方法呢？</p>
<h2>3 提高可测性的通用方法</h2>
<ol>
<li>摒弃原有的开发人员只进行单纯的代码单元测试的观念，让开发人员也进行系统级测试。作者在实践过程中最推崇的方法就是此条。具体地说，开发人员进行的是系统级测试，禁止刷行覆盖率型的单纯函数覆盖UT。由系统级接口或者功能来驱动整个测试过程。无法直接进行驱动的测试行为需要撰写模拟器或者模拟模块进行。这样开发人员会切身的感受到可控性和可观测性的重要性。进而推动系统在这两个方面的实现更易用和便于测试。由此而来的良性循环能让系统整体可测性始终处于较好水平。</li>
<li>测试人员深度了解被测系统，能够在可测性出现问题的时候及时指出问题所在。只有深度了解被测系统，详细分析系统实现逻辑和代码，做到可黑盒、可白盒测试的程度，才能提前预测可测性薄弱环节，提前预防这样的事情发生。在可测性出现问题时，及时介入和提出建设性意见。在需要进行测试代码植入以方便测试流畅进行等方面亲自动手，协助开发人员解决问题。</li>
</ol>
<p>可测性问题可能出现在系统的各个方面，但只要在系统生命周期的各个环节严格要求并辅以正确的方法，可测性问题就不会成为软件测试中不可攻破的难关。各位朋友，你遇到过哪样的可测性难题呢？如果让你从设计阶段就贯彻好的可测性要求并在整个流程中严格遵守，能否解决你的难题呢？</p>
<p>欢迎大家关注公号, 一起在技术领域互动和讨论.</p>

<p>原文地址：https://www.cnblogs.com/mythmgn/p/10948431.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-22 19:07:47 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e6%a8%a1%e5%9d%97/" title="模块">模块</a>, <a href="https://www.biecuoliao.com/tag/%e8%a7%a3%e5%86%b3/" title="解决">解决</a>, <a href="https://www.biecuoliao.com/tag/%e7%b3%bb%e7%bb%9f/" title="系统">系统</a>, <a href="https://www.biecuoliao.com/tag/%e6%94%b9%e5%8f%98/" title="改变">改变</a>, <a href="https://www.biecuoliao.com/tag/%e6%94%b9%e8%bf%9b/" title="改进">改进</a>, <a href="https://www.biecuoliao.com/tag/%e8%a7%a3%e5%86%b3%e9%97%ae%e9%a2%98/" title="解决问题">解决问题</a>, <a href="https://www.biecuoliao.com/tag/%e7%bb%8f%e9%aa%8c%e5%80%bc/" title="经验值">经验值</a>, <a href="https://www.biecuoliao.com/tag/%e4%b8%8a%e5%b1%82/" title="上层">上层</a>, <a href="https://www.biecuoliao.com/tag/%e6%a8%a1%e6%8b%9f%e5%99%a8/" title="模拟器">模拟器</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>[测试技术思考] 软件可测性分析和实践的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEvnjD0.html" rel="bookmark">测试技术&sol;网游Bug分析&sol;单机修改 视频教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				早期做的一些视频,测试技术/Bug讲解/单机修改,有兴趣的同学自行下载看吧 由于是早期录制的,有口误多包涵... 链接: http://pan.baidu.com/s/1i5JUKPf 密码: a1xs 解压密码:weimjsam 链接:http://pan.baidu.com/s/1miGQjl2 密码:iw1b 更多测试信息请加入QQ群了解[测试技术学习小组]478717918			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38B2vgM.html" rel="bookmark">关于三维制作技术的软件调研分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.序言 三维动画作为电脑美术的一个分支,是建立在动画艺术和电脑软硬件技术发展基础上而形成的一种相对的独立新型的艺术形式,其发展起来所依靠的三维制作技术,即 3D 技术,是随着计算机软硬件技术的发展而产生的一门新兴技术. 自上个世纪七十年代后期,随着计算机图形学应用的空前发展,欧美国家以电脑做工具,开始追求技术上的最大发挥,将人物造型和环境以三维形式展现.1982年,迪斯尼(Disney)推出了第一套电脑动画的电影:Tron(电脑争霸).作为三维动画的开山之作,它为后来的三维动画的发展开了很好的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Myq5qaM.html" rel="bookmark">Log4j2分析与实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当前网络上关于Log4j2的中文文章比较零散,这里整理了一下关于Log4j2比较全面的一些文章,供广大技术人员参考 Log4j2分析与实践-认识Log4j2 Log4j2分析与实践-架构 Log4j2分析与实践-配置示例 Log4j2分析与实践-配置详解 Log4j2分析与实践-Lookups Log4j2分析与实践-Appenders Log4j2分析与实践-Layouts Log4j2分析与实践-Filters Log4j2分析与实践-异步Logger Log4j2分析与实践-无垃圾地写日志			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6RLZ5M.html" rel="bookmark">测试技术的思考 ---- 读《微软的软件测试之道》有感系列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				假期期间,带着复习巩固测试基础理论的目的,开始阅读&lt;微软的软件测试之道&gt;,阅读过程中有不少启发,遂将自己的思考及学到的知识在此处做个总结记录. 1. 为什么阅读这本书? ????做了几年测试工作,随着对测试理解的加深,我发现测试理论对于日常的测试工作有较大的帮助与影响.待测系统复杂多样性的增加,要求我们也逐步去思考,如何测试,才能保证待测系统的质量,这期间就需要测试理论的支撑. ????我个人的一个观点是,一个优秀的测试工程师,或一个优秀的软件开发测试工程师,需要在三个方面持续的打磨: 理论			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4J9jEb3.html" rel="bookmark">山东大学软件质量保证与测试技术复习纲要</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				软件质量保证与测试技术复习提纲 1.3  1.5   2.1 2.3 2.5 2.6   3.3(3.3.1    扩展) 3.4 3.7.3  FSM   状态图 状态表   5.1 5.7.1 5.7.2   8.1.1 8.1.5   9.1 9.6 3.3.1    扩展 某研究所重新对其在大学以上学历的职工安排工作.其方针如下:&quot;如果年龄不满18岁,文化程度是大学,若是男性,则一律要求考研究生.若是女性,则分配到研究所办公室任行政干部:如果年龄满18岁但不足50岁,文化程度是研究生,不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPBGJz3.html" rel="bookmark">《微软的软件测试之道》读书笔记 之 结构测试技术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;微软的软件测试之道&gt;读书笔记 之 结构测试技术 2014-07-18 我们需要结构测试吗? 微软的一项试验说明了结构测试的在代码覆盖中起到的效果: 超过3000名测试员参与了这项实验,每25人一组,实验结果在所有组中都是一致的.在这项研究中, 脚本化测试:根据样式书设计的脚本化测试在被测程序上达到了标称83%的代码覆盖率. 探索性测试:然后,实验参与者允许进行每人15分钟,累计5小时的探索性测试.令人惊讶的是,代码覆盖率平均只增加了3个百分点. 结构测试:但是,当实验参与者能够分析探测过的(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgqLRO3.html" rel="bookmark">书评第003篇：《0day安全：软件漏洞分析技术（第2版）》</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本书基本信息 丛书名:安全技术大系 作者:王清(主编),张东辉.周浩.王继刚.赵双(编著) 出版社:电子工业出版社 出版时间:2011-6-1 ISBN:9787121133961 版次:1 页数:753 字数:780000 印刷时间:2011-6-1 开本:16开 纸张:胶版纸 印次:1 包装:平装 书籍封面 内容简介 本书分为5篇33章,系统.全面地介绍了Windows平台缓冲区溢出漏洞的分析.检测与防护.第一篇为漏洞exploit的基础理论和初级技术,可以引领读者迅速入门:第二篇在第一篇的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0db9gZ4.html" rel="bookmark">【渗透技术】渗透测试技术分析&lowbar;TomCat</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[渗透技术]渗透测试技术分析_TomCat 本文转自:i春秋论坛 渗透测试-中间人攻击(原理)说起“中间人攻击”我想大多数对渗透测试又了解的朋友都多少有所了解,因为我们用到的次数真是非常的多.它可以将受害者发往服务器端的流量劫持到攻击者的计算机中,隐私得不到保证. 中间人攻击(Man-in-the-MiddleAttack,简称“MITM攻击”)中间人攻击很早就成为了黑客常用的一种古老的攻击手段,并且一直到今天还具有极大的扩展空间. 在网络安全方面,MITM攻击的使用是很广泛的,曾经猖獗一时的S			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBbdlAM.html" rel="bookmark">【转】测试职业思考：如何成为一名优秀的软件测试工程师</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如何成为一名优秀的软件测试工程师                                                                                             --------记录自己阅读&lt;赢在测试&gt;读书笔记           来北京快一年了,在自己喜欢的岗位快乐的工作着,这里是自己职业的开始,一直希望自己未来在测试的岗位上走的更远,思考着如何成为一名优秀的测试工程师,最近利用每天晚上回去休息的时间,逐渐读完了&lt;赢在测试&gt;			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M68EKy3.html" rel="bookmark" class="title">移动应用跨平台开发：《用PhoneGap来开发跨平台手机应用》</a>
					<div>
						移动应用跨平台开发:&lt;用PhoneGap来开发跨平台手机应用&gt; 随着HTML5, CSS3, Javascript的发展,以及浏览器对这些特性的支持,使得手机跨平台成为一种趋势,跨平台意味 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38Zq82M.html" rel="bookmark" class="title">Atom 飞行手册（Atom flight manual）快捷键</a>
					<div>
						本列表整理自http://flight-manual.atom.io/,暂覆盖WINDOWS: 本列表功能列翻译较多参考了https://www.gitbook.com/book/wizardforc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGEgkV3.html" rel="bookmark" class="title">TXLSReadWriteII2版本导出Excel文件：</a>
					<div>
						//TXLSReadWriteII2版本导出Excel文件: procedure TForm1.N1Click(Sender: TObject); var i: Integer; aSaveDialo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02m7xAM.html" rel="bookmark" class="title">xml实现rss订阅</a>
					<div>
						RSS是一种网页内容联合格式,是XML的一种,所有的RSS文档都遵循XML1.0规范. 具体示例: &lt;span style=&quot;font-family:Microsoft YaHei;f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NaqVB3.html" rel="bookmark" class="title">Android OkHttp详解</a>
					<div>
						来源 http://frodoking.github.io/2015/03/12/android-okhttp/ 编辑推荐:稀土掘金,这是一个针对技术开发者的一个应用,你可以在掘金上获取最新最优质的技 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qvbwp4.html" rel="bookmark" class="title">内存盘</a>
					<div>
						一.简介 大多数的Linux发行版本中,内存盘默认使用的是/dev/shm 路径,文件系统类型为tmpfs,默认大小是内存实际的大小,操作这个路径就是对内存的操作.   tmpfs是一种虚拟内存文件系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vZbLa3.html" rel="bookmark" class="title">SoundTouch</a>
					<div>
						http://blog.csdn.net/leilu2008/article/details/6540575 http://www.cnblogs.com/haore147/p/3662518.htm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e5Rrw0.html" rel="bookmark" class="title">《Windows程序设计 第5版》第3章 窗口与消息 笔记</a>
					<div>
						广告先: LibUIDK界面库:制作QQ.360界面时,你能找到的最强大的界面库.基于DirectHWND技术! 3.1 窗口的创建 一个简单的win32程序如下(假设工程名为&quot;HelloW ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QqWlQ4.html" rel="bookmark" class="title">nyoj1086是否被整除（数学小技巧）</a>
					<div>
						是否被整除 时间限制:1000 ms  |  内存限制:65535 KB 难度:2 描述 一个位数不大于100万位的正整数,如果它既能被11整除又能被2的n次方整除就输出YES否则输出NO 输入 输入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mqKk0.html" rel="bookmark" class="title">Uva 10608 Friends</a>
					<div>
						题目是给出总人数,和两个人之间的朋友关系,最后求最多的朋友的人数. 思路:用并查集去求. 1 #include &lt;cstdio&gt; 2 #include &lt;cstring&gt; 3  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rkPPg4.html" rel="bookmark" class="title">hdu 2647 Reward &lpar;拓扑排序分层&rpar;</a>
					<div>
						Reward Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Subm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y7LEv4.html" rel="bookmark" class="title">手机版web相关meta配置</a>
					<div>
						若页面需默认用ie兼容内核,增加标签: 若页面需默认用ie标准内核,增加标签: --&gt; 页面标题 手机版web相关meta配置,布布扣,bubuko.com					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vQDgg0.html" rel="bookmark" class="title">hust 1062 Divisibility</a>
					<div>
						题目描述 On the planet Zoop, numbers are represented in base 62, using the digits 0, 1, . . . , 9, A, B, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eyKZZ0.html" rel="bookmark" class="title">类与类之间的关系-----转载</a>
					<div>
						类与类之间的几种关系 一.继承关系      继承指的是一个类(称为子类.子接口)继承另外的一个类(称为父类.父接口)的功能,并可以增加它自己的新功能的能力.在Java中继承关系通过关键字extend ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02Zbzp0.html" rel="bookmark" class="title">centos7系统安装oracle11g指南</a>
					<div>
						准备工作: centos7系统正常工作且已经联网. centos7有图形界面,因为后续安装有需要图形界面操作 oracle11g安装包下载完成(下载资源网址http://www.oracle.com/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzL86y3.html" rel="bookmark" class="title">在Android加入和使用Realm</a>
					<div>
						原文链接:Up and Running With Realm for Android 介绍 如果你比较关心android开发的最新动态的话,那么你肯定会听说过Realm,Realm是一个轻量级的数据库 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RnAvy0.html" rel="bookmark" class="title">热天客服喀什到那时候都好是到港的</a>
					<div>
						http://blog.zhulong.com/blog/detail5575762.htmlhttp://blog.zhulong.com/blog/detail5575772.htmlhttp:/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OykLPM.html" rel="bookmark" class="title">支付宝SDK快速入口链接</a>
					<div>
						支付宝快捷支付SDK官方网站					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pkElw3.html" rel="bookmark" class="title">iOS  更改导航栏返回按钮文字</a>
					<div>
						假如有两个ViewController A,B 修改B的返回按钮需在A页面设置 self.navigationItem.backBarButtonItem = [[UIBarButtonItem al ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02X61p4.html" rel="bookmark" class="title">Yii 2 &mdash;&mdash; 字段校验</a>
					<div>
						1.1  字段校验 1.1.1  简介 开发Web应用有一个很重要的原则,就是不要相信任何输入的数据,在使用之前必须要进行有效性检查,否则很有可能会引发各种安全性问题.Yii 2当然也不会忽略这个问题 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
